<?php

/*
 * kohinos_cooperatic
 * Copyright (C) 2019-2020  ADML63
 * Copyright (C) 2020- Cooperatic
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
namespace App\Listener;

use App\Entity\Flux;
use Doctrine\Common\EventSubscriber;
use Doctrine\ORM\Event\OnFlushEventArgs;
use Doctrine\ORM\Events;

class FluxListener implements EventSubscriber
{
    public function getSubscribedEvents()
    {
        return array(Events::onFlush);
    }

    public function onFlush(OnFlushEventArgs $args)
    {
        $em  = $args->getEntityManager();
        $uow = $em->getUnitOfWork();

        $inserted = $uow->getScheduledEntityInsertions();

        foreach ($inserted as $entity) {
            if ($entity instanceof Flux) {
                $topersists = $entity->operate($em);
                foreach ($topersists as $topersist) {
                    $class = $em->getClassMetadata(get_class($topersist));
                    $em->persist($topersist);
                    $em->getUnitOfWork()->computeChangeSet($class, $topersist);
                }
                // @TODO : do something (log, save somewhere else...) on flux persist
                //      => @tag sur un service ?
            }
        }
    }
}
